<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class RouteOptixController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Customer login
     */
    public function CustomerLogin(Request $request){

        $customerNumber = $request->input('customer_number');
        $locationNumber = $request->input('location_number');
        $password       =  $request->input('phone_number');
        if (empty($customerNumber) || empty($locationNumber) || empty($password)){
            $result = $this->responseData('Failed','Required parameters missing!');

        }else{
            $values     = (array($customerNumber,$locationNumber,$password));
            $params     = http_build_query($values);
            $response   = $this->executeCurl('Login',$params);
            $result = $this->responseData('Success',$response); 
        }  
        return $result;  
    }
   
    /**
     * Get customer invoice
     */
    public function GetInvoice(Request $request){
        $customerNumber = $request->input('customer_number');
        $locationNumber = $request->input('location_number');
        $invoice        =  $request->input('invoice');
        $division       =  $request->input('division');
       
        if (empty($customerNumber) || empty($locationNumber)  || empty($invoice) ||empty($division) ){
            $result = $this->responseData('Failed','Required parameters missing!');

        }else{
            $values     = (array($customerNumber,$locationNumber,$invoice,$division));
            $params     = http_build_query($values);
            $response   = $this->executeCurl('InvoicePDF',$params);
            $result = $this->responseData('Success',$response); 
        } 
        return $result;
    }

    /**
     * Get document
     */
    public function GetDocument(Request $request){
        $customerNumber = $request->input('customer_number');
        $locationNumber = $request->input('location_number');
        $document       = $request->input('document');
        $documentDate   = $request->input('document_date');
        $division       =  $request->input('division');

        if (empty($customerNumber) || empty($locationNumber) || empty($document) || empty($documentDate) || empty($division) ){
            $result = $this->responseData('Failed','Required parameters missing!');

        }else{
            $values     = (array($customerNumber,$locationNumber,$document . " AND [DATE] = '" . $documentDate . "'",$division));
            $params     = http_build_query($values);
            $response   = $this->executeCurl('DocumentPDF',$params);
            $result = $this->responseData('Success',$response);
        }
        return $result;
    }

    /**
     * Get service
     */
    public function GetServices(Request $request){
        $customerNumber     = $request->input('customer_number');
        $locationNumber     = $request->input('location_number');
        $division           = $request->input('division');
        $serviceStartDate   = $request->input('service_start_date');
        $serviceEndDate     = $request->input('service_end_date');
        if (empty($customerNumber) || empty($locationNumber) || empty($division) || empty($serviceStartDate) || empty($serviceEndDate)){
            $result = $this->responseData('Failed','Required parameters missing!');
        }else{
            $values     = (array($customerNumber,$locationNumber,$division,$serviceStartDate,$serviceEndDate));
            $params     = http_build_query($values);
            $response   = $this->executeCurl('Services',$params);
            $result     = $this->responseData('Success',$response);
        }
        return $result;
    }
    
    /**
     * Pay invoice
     */
    public function Payinvoice(Request $request){
        $division       = $request->input('division');
        $customerNumber = $request->input('customer_number');
        $locationNumber = $request->input('location_number');
        $invoiceNumber  = $request->input('invoices');
        $invoiceAmount  = $request->input('amounts');
        $paymentType    = $request->input('payment_type');

        $creditcardNumber   = "''";
        $expiryDate         = "''";
        $creditcardName     = "''";
        $bankAccountNumber  = "''";
        $bankAccountRouting = "''";
        $bankAccountType    = "''";

        if ($paymentType = "CC"){
            $creditcardNumber   = $request->input('creditcard_number');
            $expiryDate         = $request->input('expiry_date');
            $creditcardName     = $request->input('creditcard_name');  
        }else {
            $creditcardName     = $request->input('ach_name');
            $bankAccountNumber  = $request->input('ach_number');
            $bankAccountRouting = $request->input('ach_routing');
            $bankAccountType    = $request->input('ach_type');
        }
        $today = date('Y-m-d');
        if ($paymentType == "CC"){
            if (empty($creditcardNumber) || empty($expiryDate) || empty($creditcardName)) {
                $result = $this->responseData('Failed','Required parameters missing!');
            }
            else {
                // evaluate expiry date
                if (strpos($expiryDate,'/') != '2'){
                    $result = $this->responseData('Failed','Invalid expiry date');
                }
                $month = mb_substr($expiryDate,0,2);
                if ($month < 1 || $month > 12){
                    $result = $this->responseData('Failed','Invalid expiry month');
                }
                $year = mb_substr($expiryDate,3,2);
                if ($year < date('y') || $year > 99){
                    $result = $this->responseData('Failed','Invalid expiry year');
                }
                if ($year == date('y') && $month < date('m')){
                    $result = $this->responseData('Failed','Invalid expiry month');
                }
                $expiryDate = str_replace('/','',$expiryDate);

            }
        }
        if ($paymentType == "ACH"){
            if (empty($creditcardName) || empty($bankAccountNumber) || empty($bankAccountRouting)) {
                $result = $this->responseData('Failed','Required parameters missing!');
            }
        }
        $values     = (array($division,$customerNumber,$locationNumber,$invoiceNumber,$invoiceAmount,$creditcardNumber,$expiryDate,$creditcardName,$today,$bankAccountNumber,$bankAccountRouting,$bankAccountType));
        $params     = http_build_query($values);
        $response   = $this->executeCurl('PayInvoice',$params);
        $result = $this->responseData('Success',$response);
        return $result;

    }

    /**
     * request response
     */
    public function responseData($status,$data){
        $response = array(
            'status' => $status,
            "data"   => $data
        );
        return $response;

    }
    /**
     * Executing API call
     */
    private function executeCurl($typeUrl,$params){

        $hostname = env("ROUTE_OPTIX_IP", "");
        $port     = env("ROUTE_OPTIX_PORT", "");
        $server   = $hostname.':'.$port;
        $url      = 'http://'.$server.'/GET?COMMAND='.$typeUrl.'&'.$params;
            
        $defaults = array( 
			CURLOPT_URL => $url, 
			CURLOPT_HEADER => 0, 
			CURLOPT_RETURNTRANSFER => TRUE, 
			CURLOPT_SSL_VERIFYPEER => FALSE,
			CURLOPT_CONNECTTIMEOUT => 15 
		); 
    
		$ch = curl_init(); 
		curl_setopt_array($ch, ($defaults)); 
		if ( ! $response = curl_exec($ch)) 
		{ 
			echo (curl_error($ch)); 
		} 
        curl_close($ch); 
        return $response;
    }
    
}
